using System;
using System.Windows.Forms;
using System.Drawing;
using System.Runtime.InteropServices;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace ADX_Ol_Navigation_Pane_CS
{
	/// <summary>
	/// Summary description for ADXOlForm1.
	/// </summary>
	public class ADXOlForm1 : AddinExpress.OL.ADXOlForm
	{
		private Label label1;
		private ComboBox SelectComboBox;
		private Button AddGroup;
		private Button AddFavorite;
		private Button ButtonMinimize;
		private Button ButtonVisible;
		private System.ComponentModel.IContainer components = null;

		public ADXOlForm1()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.SelectComboBox = new System.Windows.Forms.ComboBox();
			this.AddGroup = new System.Windows.Forms.Button();
			this.AddFavorite = new System.Windows.Forms.Button();
			this.ButtonMinimize = new System.Windows.Forms.Button();
			this.ButtonVisible = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(12, 134);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(95, 13);
			this.label1.TabIndex = 15;
			this.label1.Text = "Select the module:";
			// 
			// SelectComboBox
			// 
			this.SelectComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.SelectComboBox.FormattingEnabled = true;
			this.SelectComboBox.Items.AddRange(new object[] {
            "Mail",
            "Calendar",
            "Contacts",
            "Tasks",
            "Notes",
            "Folder List",
            "Shortcuts",
            "Journal"});
			this.SelectComboBox.Location = new System.Drawing.Point(12, 152);
			this.SelectComboBox.Name = "SelectComboBox";
			this.SelectComboBox.Size = new System.Drawing.Size(172, 21);
			this.SelectComboBox.TabIndex = 14;
			this.SelectComboBox.SelectedIndexChanged += new System.EventHandler(this.SelectComboBox_SelectedIndexChanged);
			// 
			// AddGroup
			// 
			this.AddGroup.Location = new System.Drawing.Point(12, 99);
			this.AddGroup.Name = "AddGroup";
			this.AddGroup.Size = new System.Drawing.Size(172, 23);
			this.AddGroup.TabIndex = 13;
			this.AddGroup.Text = "Add New Group";
			this.AddGroup.UseVisualStyleBackColor = true;
			this.AddGroup.Click += new System.EventHandler(this.AddGroup_Click);
			// 
			// AddFavorite
			// 
			this.AddFavorite.Location = new System.Drawing.Point(12, 70);
			this.AddFavorite.Name = "AddFavorite";
			this.AddFavorite.Size = new System.Drawing.Size(172, 23);
			this.AddFavorite.TabIndex = 12;
			this.AddFavorite.Text = "Add to Favorite Folders";
			this.AddFavorite.UseVisualStyleBackColor = true;
			this.AddFavorite.Click += new System.EventHandler(this.AddFavorite_Click);
			// 
			// PaneMinimize
			// 
			this.ButtonMinimize.Location = new System.Drawing.Point(12, 41);
			this.ButtonMinimize.Name = "PaneMinimize";
			this.ButtonMinimize.Size = new System.Drawing.Size(172, 23);
			this.ButtonMinimize.TabIndex = 11;
			this.ButtonMinimize.Text = "Minimize Navigation Pane";
			this.ButtonMinimize.UseVisualStyleBackColor = true;
			this.ButtonMinimize.Click += new System.EventHandler(this.ButtonMinimize_Click);
			// 
			// PaneVisible
			// 
			this.ButtonVisible.AutoSize = true;
			this.ButtonVisible.Location = new System.Drawing.Point(12, 12);
			this.ButtonVisible.Name = "PaneVisible";
			this.ButtonVisible.Size = new System.Drawing.Size(172, 23);
			this.ButtonVisible.TabIndex = 10;
			this.ButtonVisible.Text = "Navigation Pane Off";
			this.ButtonVisible.UseVisualStyleBackColor = true;
			this.ButtonVisible.Click += new System.EventHandler(this.ButtonVisible_Click);
			// 
			// ADXOlForm1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(300, 300);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.SelectComboBox);
			this.Controls.Add(this.AddGroup);
			this.Controls.Add(this.AddFavorite);
			this.Controls.Add(this.ButtonMinimize);
			this.Controls.Add(this.ButtonVisible);
			this.Name = "ADXOlForm1";
			this.Text = "ADXOlForm1";
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		private void ADXOlForm1_ADXBeforeFormShow()
		{
			if (this.ExplorerObj != null)
			{
				if ((this.AddinModule as AddinModule)._outlookVersion == 2000 || (this.AddinModule as AddinModule)._outlookVersion == 2002)
				{
					ButtonMinimize.Enabled = false;
					AddFavorite.Enabled = false;
					ButtonVisible.Enabled = false;
					AddGroup.Enabled = false;
					SelectComboBox.Enabled = false;
				}
				else
				{
					if ((ExplorerObj as Outlook._Explorer).IsPaneVisible(Outlook.OlPane.olNavigationPane))
						ButtonVisible.Text = "Navigation Pane Off";
					else
						ButtonVisible.Text = "Navigation Pane On";
				}

				if ((this.AddinModule as AddinModule)._outlookVersion == 2007)
				{
					Outlook.NavigationPane navigationPane = (ExplorerObj as Outlook._Explorer).NavigationPane;
					if (navigationPane != null)
						try
						{
							if (navigationPane.IsCollapsed)
								ButtonMinimize.Text = "Maximize Navigation Pane";
							else
								ButtonMinimize.Text = "Minimize Navigation Pane";
							SelectComboBox.SelectedIndex = 0;

							ButtonMinimize.Enabled = true;
							AddFavorite.Enabled = true;
						}
						finally
						{
							Marshal.ReleaseComObject(navigationPane);
						}
				}
				else
				{
					ButtonMinimize.Enabled = false;
					AddFavorite.Enabled = false;
				}
			}
		}

		private void ButtonVisible_Click(object sender, EventArgs e)
		{
			if ((ExplorerObj as Outlook._Explorer).IsPaneVisible(Outlook.OlPane.olNavigationPane))
			{
				(ExplorerObj as Outlook._Explorer).ShowPane(Outlook.OlPane.olNavigationPane, false);
				ButtonVisible.Text = "Navigation Pane On";
			}
			else
			{
				(ExplorerObj as Outlook._Explorer).ShowPane(Outlook.OlPane.olNavigationPane, true);
				ButtonVisible.Text = "Navigation Pane Off";
			}
		}

		private void ButtonMinimize_Click(object sender, EventArgs e)
		{
			Outlook.NavigationPane navigationPane = (ExplorerObj as Outlook._Explorer).NavigationPane;
			if (navigationPane != null)
				try
				{
					if (navigationPane.IsCollapsed)
						ButtonMinimize.Text = "Minimize Navigation Pane";
					else
						ButtonMinimize.Text = "Maximize Navigation Pane";
					navigationPane.IsCollapsed = !navigationPane.IsCollapsed;
				}
				finally
				{
					Marshal.ReleaseComObject(navigationPane);
				}
		}

		private void AddFavorite_Click(object sender, EventArgs e)
		{
			Outlook.NavigationPane navigationPane = (ExplorerObj as Outlook._Explorer).NavigationPane;
			if (navigationPane != null)
				try
				{
					Outlook.NavigationModule currentModule = navigationPane.CurrentModule;
					if (currentModule != null)
						try
						{
							if (currentModule.NavigationModuleType == Outlook.OlNavigationModuleType.olModuleMail)
							{
								Outlook.Folder folder = (ExplorerObj as Outlook._Explorer).CurrentFolder as Outlook.Folder;
								if (folder != null)
									try
									{
										Outlook.NavigationModules modules = navigationPane.Modules;
										if (modules != null)
											try
											{
												Outlook.MailModule mailModule = modules.GetNavigationModule(Outlook.OlNavigationModuleType.olModuleMail) as Outlook.MailModule;
												if (mailModule != null)
													try
													{
														Outlook.NavigationGroups navigationGroups = mailModule.NavigationGroups;
														if (navigationGroups != null)
															try
															{
																Outlook.NavigationGroup mailGroup = navigationGroups.GetDefaultNavigationGroup(Outlook.OlGroupType.olFavoriteFoldersGroup);
																if (mailGroup != null)
																	try
																	{
																		Outlook.NavigationFolders navigationFolders = mailGroup.NavigationFolders;
																		if (navigationFolders != null)
																			try
																			{
																				mailGroup.NavigationFolders.Add(folder);
																			}
																			finally
																			{
																				Marshal.ReleaseComObject(navigationFolders);
																			}
																	}
																	finally
																	{
																		Marshal.ReleaseComObject(mailGroup);
																	}
															}
															finally
															{
																Marshal.ReleaseComObject(navigationGroups);
															}
													}
													finally
													{
														Marshal.ReleaseComObject(mailModule);
													}
											}
											finally
											{
												Marshal.ReleaseComObject(modules);
											}
									}
									finally
									{
										Marshal.ReleaseComObject(folder);
									}
							}
							else
							{
								MessageBox.Show("This option works for Mail module only", "Add-in Express");
							}
						}
						finally
						{
							Marshal.ReleaseComObject(currentModule);
						}
				}
				finally
				{
					Marshal.ReleaseComObject(navigationPane);
				}
		}

		private void AddGroup_Click(object sender, EventArgs e)
		{
			Outlook.NavigationPane navigationPane = (ExplorerObj as Outlook._Explorer).NavigationPane;
			if (navigationPane != null)
				try
				{
					Outlook.NavigationModule currentModule = navigationPane.CurrentModule;
					if (currentModule != null)
						try
						{
							switch (currentModule.NavigationModuleType)
							{
								case Outlook.OlNavigationModuleType.olModuleCalendar:
									if ((this.AddinModule as AddinModule)._outlookVersion == 2007)
										calendarAddNewGroup(navigationPane);
									break;
								case Outlook.OlNavigationModuleType.olModuleContacts:
									if ((this.AddinModule as AddinModule)._outlookVersion == 2007)
										contactsAddNewGroup(navigationPane);
									break;
								case Outlook.OlNavigationModuleType.olModuleJournal:
									if ((this.AddinModule as AddinModule)._outlookVersion == 2007)
										journalAddNewGroup(navigationPane);
									break;
								case Outlook.OlNavigationModuleType.olModuleNotes:
									if ((this.AddinModule as AddinModule)._outlookVersion == 2007)
										notesAddNewGroup(navigationPane);
									break;
								case Outlook.OlNavigationModuleType.olModuleTasks:
									if ((this.AddinModule as AddinModule)._outlookVersion == 2007)
										tasksAddNewGroup(navigationPane);
									break;
								case Outlook.OlNavigationModuleType.olModuleShortcuts:
									shortcutsAddNewGroup();
									break;
								case Outlook.OlNavigationModuleType.olModuleMail:
								case Outlook.OlNavigationModuleType.olModuleFolderList:
									break;
							}
						}
						finally
						{
							Marshal.ReleaseComObject(currentModule);
						}
				}
				finally
				{
					Marshal.ReleaseComObject(navigationPane);
				}
		}

		private void SelectComboBox_SelectedIndexChanged(object sender, EventArgs e)
		{
			Outlook.NavigationPane navigationPane = (ExplorerObj as Outlook._Explorer).NavigationPane;
			if (navigationPane != null)
				try
				{
					switch (SelectComboBox.SelectedIndex)
					{
						case 0:
							ComboBoxSelectIndex(navigationPane, Outlook.OlNavigationModuleType.olModuleMail);
							break;
						case 1:
							ComboBoxSelectIndex(navigationPane, Outlook.OlNavigationModuleType.olModuleCalendar);
							break;
						case 2:
							ComboBoxSelectIndex(navigationPane, Outlook.OlNavigationModuleType.olModuleContacts);
							break;
						case 3:
							ComboBoxSelectIndex(navigationPane, Outlook.OlNavigationModuleType.olModuleTasks);
							break;
						case 4:
							ComboBoxSelectIndex(navigationPane, Outlook.OlNavigationModuleType.olModuleNotes);
							break;
						case 5:
							ComboBoxSelectIndex(navigationPane, Outlook.OlNavigationModuleType.olModuleFolderList);
							break;
						case 6:
							ComboBoxSelectIndex(navigationPane, Outlook.OlNavigationModuleType.olModuleShortcuts);
							break;
						case 7:
							ComboBoxSelectIndex(navigationPane, Outlook.OlNavigationModuleType.olModuleJournal);
							break;
					}
				}
				finally
				{
					Marshal.ReleaseComObject(navigationPane);
				}
		}

		private void ComboBoxSelectIndex(Outlook.NavigationPane navigationPane, Outlook.OlNavigationModuleType moduleType)
		{
			Outlook.NavigationModules navigationModules = navigationPane.Modules;
			if (navigationModules != null)
				try
				{
					navigationPane.CurrentModule = navigationPane.Modules.GetNavigationModule(moduleType);
				}
				finally
				{
					Marshal.ReleaseComObject(navigationModules);
				}
		}

		private void calendarAddNewGroup(Outlook.NavigationPane navigationPane)
		{
			Outlook.NavigationModules modules = navigationPane.Modules;
			if (modules != null)
				try
				{
					Outlook.CalendarModule calendarModule = modules.GetNavigationModule(Outlook.OlNavigationModuleType.olModuleCalendar) as Outlook.CalendarModule;
					if (calendarModule != null)
						try
						{
							Outlook.NavigationGroups navigationGroups = calendarModule.NavigationGroups;
							if (navigationGroups != null)
								try
								{
									navigationGroups.Create("Custom New Group");
								}
								finally
								{
									Marshal.ReleaseComObject(navigationGroups);
								}
						}
						finally
						{
							Marshal.ReleaseComObject(calendarModule);
						}
				}
				finally
				{
					Marshal.ReleaseComObject(modules);
				}
		}

		private void contactsAddNewGroup(Outlook.NavigationPane navigationPane)
		{
			Outlook.NavigationModules modules = navigationPane.Modules;
			if (modules != null)
				try
				{
					Outlook.ContactsModule contactsModule = modules.GetNavigationModule(Outlook.OlNavigationModuleType.olModuleContacts) as Outlook.ContactsModule;
					if (contactsModule != null)
						try
						{
							Outlook.NavigationGroups navigationGroups = contactsModule.NavigationGroups;
							if (navigationGroups != null)
								try
								{
									navigationGroups.Create("Custom New Group");
								}
								finally
								{
									Marshal.ReleaseComObject(navigationGroups);
								}
						}
						finally
						{
							Marshal.ReleaseComObject(contactsModule);
						}
				}
				finally
				{
					Marshal.ReleaseComObject(modules);
				}
		}

		private void tasksAddNewGroup(Outlook.NavigationPane navigationPane)
		{
			Outlook.NavigationModules modules = navigationPane.Modules;
			if (modules != null)
				try
				{
					Outlook.TasksModule tasksModule = modules.GetNavigationModule(Outlook.OlNavigationModuleType.olModuleTasks) as Outlook.TasksModule;
					if (tasksModule != null)
						try
						{
							Outlook.NavigationGroups navigationGroups = tasksModule.NavigationGroups;
							if (navigationGroups != null)
								try
								{
									navigationGroups.Create("Custom New Group");
								}
								finally
								{
									Marshal.ReleaseComObject(navigationGroups);
								}
						}
						finally
						{
							Marshal.ReleaseComObject(tasksModule);
						}
				}
				finally
				{
					Marshal.ReleaseComObject(modules);
				}
		}

		private void notesAddNewGroup(Outlook.NavigationPane navigationPane)
		{
			Outlook.NavigationModules modules = navigationPane.Modules;
			if (modules != null)
				try
				{
					Outlook.NotesModule notesModule = modules.GetNavigationModule(Outlook.OlNavigationModuleType.olModuleNotes) as Outlook.NotesModule;
					if (notesModule != null)
						try
						{
							Outlook.NavigationGroups navigationGroups = notesModule.NavigationGroups;
							if (navigationGroups != null)
								try
								{
									navigationGroups.Create("Custom New Group");
								}
								finally
								{
									Marshal.ReleaseComObject(navigationGroups);
								}
						}
						finally
						{
							Marshal.ReleaseComObject(notesModule);
						}
				}
				finally
				{
					Marshal.ReleaseComObject(modules);
				}
		}

		private void shortcutsAddNewGroup()
		{
			(this.AddinModule as AddinModule).adxOlBarShortcutManager1.Groups.Add("Custom New Group");
		}

		private void journalAddNewGroup(Outlook.NavigationPane navigationPane)
		{
			Outlook.NavigationModules modules = navigationPane.Modules;
			if (modules != null)
				try
				{
					Outlook.JournalModule journalModule = modules.GetNavigationModule(Outlook.OlNavigationModuleType.olModuleJournal) as Outlook.JournalModule;
					if (journalModule != null)
						try
						{
							Outlook.NavigationGroups navigationGroups = journalModule.NavigationGroups;
							if (navigationGroups != null)
								try
								{
									navigationGroups.Create("Custom New Group");
								}
								finally
								{
									Marshal.ReleaseComObject(navigationGroups);
								}
						}
						finally
						{
							Marshal.ReleaseComObject(journalModule);
						}
				}
				finally
				{
					Marshal.ReleaseComObject(modules);
				}
		}
	}
}

